// EDuardo Rosso
// types for Hi-Tech C
// ***********************************************
// * Types definitions                           *
// ***********************************************
//
typedef union		{	// charX
	 unsigned char CHAR;	// Char
	 struct	{			// Nibbles x 4 bits
		 unsigned Lo:4;	// Lo
		 unsigned Hi:4;	// Hi
		} Nb4;
	 struct	{			// BITs
		 unsigned b00 :1;
		 unsigned b01 :1;
		 unsigned b02 :1;
		 unsigned b03 :1;
		 unsigned b04 :1;
		 unsigned b05 :1;
		 unsigned b06 :1;
		 unsigned b07 :1;
		} BITs;		
	} charX;
//
typedef union		{	// intX
	 unsigned int  INT;		// Int
	 unsigned char CHARs[2];	// Char 2 (0x0:Lo; 0x1:Hi)
	 struct	{				// BITs
		 unsigned b00 :1;
		 unsigned b01 :1;
		 unsigned b02 :1;
		 unsigned b03 :1;
		 unsigned b04 :1;
		 unsigned b05 :1;
		 unsigned b06 :1;
		 unsigned b07 :1;
		 unsigned b08 :1;
		 unsigned b09 :1;
		 unsigned b0A :1;
		 unsigned b0B :1;
		 unsigned b0C :1;
		 unsigned b0D :1;
		 unsigned b0E :1;
		 unsigned b0F :1;
		} BITs;
	 struct	{				// Nibbles x 4 bits
		 unsigned LL	:4;
		 unsigned LH	:4;
		 unsigned HL	:4;
		 unsigned HH	:4;
		} Nb4;
	 struct	{				// Nibbles x 8 bits
		unsigned char Lo; 	// CharL
		unsigned char Hi; 	// CharH
		} Nb8;
	} intX;	

//
typedef union		{	// longX
	 unsigned char CHARs[4];	// Char 4 (0x0:LLo; 0x1:LHi; 0x2:HLo; 0x3:HHi;)
	 unsigned int INTs[2]; 	// Int 2 (0x0:Lo; 0x1:Hi)
	 struct	{				// Nibbles x 4 bits
		 unsigned LLL	:4;
		 unsigned LLH	:4;
		 unsigned LHL	:4;
		 unsigned LHH	:4;
		 unsigned HLL	:4;
		 unsigned HLH	:4;
		 unsigned HHL	:4;
		 unsigned HHH	:4;
		} Nb4;
	 struct	{				// Nibbles x 8 bits
		 unsigned char LL;
		 unsigned char LH;
		 unsigned char HL;
		 unsigned char HH;
		} Nb8;
	 struct	{				// Nibbles x 16 bits
		unsigned int Lo; 	// IntL
		unsigned int Hi; 	// IntH
		} Nb16;
	 struct	{				// BITs
		 unsigned b00 :1;
		 unsigned b01 :1;
		 unsigned b02 :1;
		 unsigned b03 :1;
		 unsigned b04 :1;
		 unsigned b05 :1;
		 unsigned b06 :1;
		 unsigned b07 :1;
		 unsigned b08 :1;
		 unsigned b09 :1;
		 unsigned b0A :1;
		 unsigned b0B :1;
		 unsigned b0C :1;
		 unsigned b0D :1;
		 unsigned b0E :1;
		 unsigned b0F :1;
		 unsigned b10 :1;
		 unsigned b11 :1;
		 unsigned b12 :1;
		 unsigned b13 :1;
		 unsigned b14 :1;
		 unsigned b15 :1;
		 unsigned b16 :1;
		 unsigned b17 :1;
		 unsigned b18 :1;
		 unsigned b19 :1;
		 unsigned b1A :1;
		 unsigned b1B :1;
		 unsigned b1C :1;
		 unsigned b1D :1;
		 unsigned b1E :1;
		 unsigned b1F :1;
		} BITs;
	 signed long LONG;
	}longX;
//